;--------------------------------------------------------------------------------;
;                                                                                ;
; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX    XX    XXXXXXXXXXXXXXXXXXXX ;
; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX  XXXXXX  XXXXXXXXXXXXXXXXXXXX ;
;   XX                                                XX                         ;
;   XX                                                                           ;
;   XX        XXXX    XXXX  XX  XXXX  XX    XXXX    XXXXXX  XXXX  XX    XXXX     ;
;   XX      XXXXXXXX  XXXXXXXX  XXXXXXXX  XXXXXXXX  XXXXXX  XXXXXXXX  XXXXXXXX   ;
;   XX  XX  XX    XX    XXXXXX    XXXXXX  XX    XX    XX      XXXXXX  XX    XX   ;
;   XXXXXX  XX    XX    XX  XX    XX  XX  XX    XX    XX      XX  XX  XX    XX   ;
;   XXXXXX  XX    XX    XX  XX    XX  XX  XX    XX    XX      XX  XX        XX   ;
;   XX  XX  XX    XX    XX  XX    XX  XX  XX    XX    XX      XX  XX    XXXXXX   ;
;   XX      XXXXXXXX    XX        XX      XXXXXXXX    XX      XX      XX    XX   ;
;   XX      XX          XX        XX      XX          XX      XX      XX    XX   ;
;   XX      XX    XX    XX        XX      XX    XX    XX      XX      XX    XX   ;
;   XX      XX    XX    XX        XX      XX    XX    XX      XX      XX    XX   ;
; XXXXXXXX  XXXXXXXX  XXXXXX    XXXXXX    XXXXXXXX  XXXXXX  XXXXXX    XXXXXXXXXX ;
; XXXXXXXX    XXXX    XXXXXX    XXXXXX      XXXX    XXXXXX  XXXXXX      XXXXXXXX ;
;                                                                                ;
; Ferreira: Portuguese Stallion                                                  ;
; (c)2008-2015 Lovergine 'Rastignac' Savino                                      ;
;                                                                                ;
;--------------------------------------------------------------------------------;

    processor 6502
    include vcs.h


;-----------------------------------------------------------------------------
;                                                                   CONSTANTES
;-----------------------------------------------------------------------------

MusicVolume       equ 5
Music60Duration   equ 15
Music50Duration   equ 12

TpZoneSize        equ 143


;-----------------------------------------------------------------------------
;                                                                    VARIABLES
;-----------------------------------------------------------------------------

    SEG.U VARS
    ORG $80

Random     ds 1      ; Random seed

VideoMode  ds 1      ; 0=NTSC60, 1=PAL60, 2=PAL50
Palette    ds 1      ; 0=NTSC, 1=PAL, 2=BW/SECAM

LinesTitle ds 1      ; Number of lines per title line

Wheels     ds 1      ; Alternance Wheels
LineIncr   ds 1      ; LineIncr
LineStart  ds 1      ; LineStart

F40x       ds 1      ; F40's X

P1x        ds 1      ; Bad1's X
P1y        ds 1      ; Bad1's Y
P1g        ds 1      ; Bad1's sprite data (first line pointer)
P1c        ds 1      ; Bad1's color

P2x        ds 1      ; Bad2's X
P2y        ds 1      ; Bad2's Y
P2g        ds 1      ; Bad2's sprite data (first line pointer)
P2c        ds 1      ; Bad2's color

P3x        ds 1
P3y        ds 1
P3g        ds 1
P3c        ds 1

P4x        ds 1
P4y        ds 1
P4g        ds 1
P4c        ds 1


DoBrake    ds 1      ; Do we brake ?
BrakeLines ds 1      ; How many skid marks braking lines



NoteCurrent  ds 1
NoteDuration ds 1


ScrollSpeed  ds 1

MenuNext     ds 1
MenuCurrent  ds 1



PhraseToDisplay ds 1


PosInPhraseInit ds 1
PosInAlphaInit  ds 1

PosInPhrase ds 1
PosInAlpha  ds 1




;;;TempPointer ds 2     ; Pointeur
;TempVar1  ds 1
;TempVar2  ds 1
;TempVar3  ds 1
;TempVar4  ds 1




TpOneSymbol ds 1     ; TwoPlayers, symbol of first player
TpTwoSymbol ds 1     ; TwoPlayers, symbol of second player
TpOneLine   ds 1     ; TwoPlayers, line of first player
TpTwoLine   ds 1     ; TwoPlayers, line of second player

TpWhichCarFirst ds 1
TpBeforeCars  ds 1
TpBetweenCars ds 1
TpAfterCars   ds 1



    echo ">>>>>",(*-$80) , "bytes of RAM used <<<<<"
    echo ">>>>>",($100 - *) , "bytes of RAM left <<<<<"
    SEG CODE

    org $F000

;=============================================================================
;                                                                   ROM HEADER
;=============================================================================
   .byte "FERREIRA Portuguese Stallion  v0.0.3a "
   .byte " (c)2008-2015 Lovergine 'Rastignac' Savino"
   .byte #13
   .byte #10
   .byte #26
   .byte #0

;=============================================================================
;                                                               INITIALISATION
;=============================================================================
Start                ; Program starts here
    ldy INTIM        ; Timer used as random seed
    sei
    cld
    ldx #255
    txs
    lda #0
InitRam
    sta 0,X
    dex
    BNE InitRam
    sty Random       ; Random seed saved

Reset
    lda SWCHB        ; Reset pressed ?
    and #1
    BEQ Reset        ; Waiting for release

Select
    lda SWCHB        ; Select pressed ?
    and #2
    BEQ Select       ; Waiting for release

;=============================================================================
;                                                                   TITLE INIT
;=============================================================================
IntroStart

;;;;lda #76          ; Screen real center
    lda #75          ; Screen center
    sta F40x         ; Ferreira's position
    ldx #1           ; Set player1 (Ferreira)
    jsr SetXPos      ; Call to repositioning code

;;;;lda #76+3        ; Car's center
    lda #75+3        ; Car's center
    ldx #4           ; Set ball (Car's windows)
    jsr SetXPos      ; Call to repositioning code

;;;;lda #76          ; Screen center
    lda #75          ; Screen center
    ldx #0           ; Set player0 (Scrolling Text)
    jsr SetXPos      ; Call to repositioning code

    sta WSYNC
    sta HMOVE        ; Set positions
                     ; and now we must wait 24 cycles for hmclr

    lda #1
    sta NoteDuration ; end of note
    sta NoteCurrent  ; end of music

    lda #0
    sta LineStart    ; LineStart
    sta COLUBK       ; Background Color (Black)
;;not needed;; sta LineIncr     ; LineIncr
;;not needed;; sta Wheels        ; Animation Wheels
    sta REFP0        ; Reflection Player0
    sta MenuCurrent  ; Current Menu Choice

    sta HMCLR        ; Stop moves


;=============================================================================
;                                                              TITLE MAIN LOOP
;=============================================================================
TitleMainLoop
   ;lda #0           ; already a=0
    ldx #2
    sta VBLANK       ; Start of vertical blank processing
    stx VSYNC
    sta WSYNC        ; 3 scanlines of VSYNCH signal...
    sta WSYNC
    sta WSYNC
    sta VSYNC

    lda #42          ; duration of vblank
    sta TIM64T

    jsr SetPalette   ; Call to set the colors palette

    ldx Palette      ; Palette to use
    lda RedFerreira,X
    sta COLUP1       ; Ferreira color
    lda RedTitle,X
    sta COLUPF       ; Title color

    lda #0           ;
    sta CTRLPF       ; Non-mirror playfield


; Road:  X=[49-103]  (28 steps)
; [49-57] [59-67] [69-81] [85-93] [95-103]
    lda F40x
    cmp #95
    BCS MenuChoice5  ; if >=95
    cmp #85
    BCS MenuChoice4  ; if >=85
    cmp #69
    BCS MenuChoice3  ; if >=69
    cmp #59
    BCS MenuChoice2  ; if >=59

MenuChoice1
    lda #1
    sta MenuNext
    sta ScrollSpeed
   ;jmp MenuSelection
    bne MenuSelection ; already NE

MenuChoice2
    lda #2
    sta MenuNext
    lda #3
    sta ScrollSpeed
   ;jmp MenuSelection
    bne MenuSelection ; already NE

MenuChoice3
    lda #3
    sta MenuNext
    sta ScrollSpeed
   ;jmp MenuSelection
    bne MenuSelection ; already NE


MenuChoice4
    lda #4
    sta MenuNext
    lda #5
    sta ScrollSpeed
   ;jmp MenuSelection
    bne MenuSelection ; already NE

MenuChoice5
    lda #5
    sta MenuNext
    lda #3
    sta ScrollSpeed
   ;jmp MenuSelection
  ;;bne MenuSelection ; already NE ; and not needed


MenuSelection
    lda MenuNext
    cmp MenuCurrent
    beq MenuScrollSpeed ; Same selection

AnotherSelection
    sta MenuCurrent
    tax
    lda PhraseTable-1,X
    sta PhraseToDisplay
    sta PosInPhraseInit
    tax
    lda Phrase-1,X
    sta PosInAlphaInit


MenuScrollSpeed
    lda LineStart
    clc
    adc ScrollSpeed
    sta LineStart
    sta LineIncr

    lda #4           ; Size of each BigLetters' line
    sta LinesTitle


WaitForVblankEnd
    lda INTIM
    bne WaitForVblankEnd
    sta VBLANK

;-----------------------------------------------------------------------------
;                                                                  BIG LETTERS
;-----------------------------------------------------------------------------
    jsr BigLetters


;-----------------------------------------------------------------------------
;                                                               SCROLLING TEXT
;-----------------------------------------------------------------------------
    ldx Palette      ; Palette to use
    lda LightBlue,X
    sta COLUPF       ; Playfield color

    lda #33
    sta CTRLPF       ; PlayField = Reflect + ball4pixels


    lda PosInPhraseInit
    sta PosInPhrase
    lda PosInAlphaInit
    sta PosInAlpha


    ldy #95          ; 95 lines (scrolling text)

TitleScrollLoop
    dec LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    sta COLUP0       ; Rainbow text
    asl              ; Shift one bit
    sta PF0          ; Playfield0

ScrollBegin
    ldx PosInAlpha   ; Pointer to current graph
    lda Alphabet,X   ; Current's graph
    bne ScrollDisplay  ; If not empty, display it

ScrollCharEnd
    lda #1           ; Display just a line dot
    sta GRP0
    dec PosInPhrase  ; Next char

ScrollNextChar
    ldx PosInPhrase  ; Char's number
    lda Phrase-1,X   ; Phrase's letter using char's number
    sta PosInAlpha
    bne ScrollEnd    ; Char0 is sentence's end

PhraseEnded
    ldx PhraseToDisplay
    stx PosInPhrase  ; End of the sentence
    lda Phrase-1,X
    sta PosInAlpha
    bne ScrollEnd    ; already NE (?)
   ;jmp ScrollEnd

ScrollDisplay
    sta GRP0
    inc PosInAlpha   ; Next line to display

ScrollEnd
    dey
    bne TitleScrollLoop



ScrollOneBlankLine
    dec LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    lda #0           ; Blanking scrolling text
    sta GRP0


ScrollBeginInit
    ldx PosInAlphaInit
    lda Alphabet,X
    bne ScrollDisplayInit
ScrollCharEndInit
    dec PosInPhraseInit
ScrollNextCharInit
    ldx PosInPhraseInit
    lda Phrase-1,X
    sta PosInAlphaInit
    bne ScrollEndInit
PhraseEndInit
    ldx PhraseToDisplay
    stx PosInPhraseInit
    lda Phrase-1,X
    sta PosInAlphaInit
    bne ScrollEndInit
ScrollDisplayInit
    inc PosInAlphaInit
ScrollEndInit


;-----------------------------------------------------------------------------
;                                                           TITLE FERREIRA CAR
;-----------------------------------------------------------------------------

    ldy #30          ; Ferreira's number of lines
TitleF40
    dec LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0

    lda F40-1,Y      ; F40's sprite
    sta GRP1         ; F40's sprite
    lda F40Ball-1,Y  ; F40's windows
    sta ENABL        ; Ball

    dey
    bne TitleF40


    sta WSYNC
    sty PF0          ; already y=0
    sty PF1
    sty GRP0


    lda VideoMode
    cmp #2
    bne MenuNotPal50

MenuPal50
    lda #3           ; BigLetters again (but smaller) if 50hz
    sta LinesTitle
    lda #0
    sta CTRLPF       ; Non-mirror playfield
    jsr BigLetters
    sta WSYNC        ; 312 lines when 50hz

MenuNotPal50
    lda #40          ; end of screen duration
    sta TIM64T

    lda #2
    sta VBLANK       ; End of screen / blanking


    lda Wheels
    eor #8           ; XOR entre 0 et 8
    sta Wheels
    sta REFP1        ; Player1 Reflection


;-----------------------------------------------------------------------------
;                                                                  INTRO MUSIC
;-----------------------------------------------------------------------------


StillPlaying
    ldx NoteCurrent
    lda PartitionBegin-1,X
    cmp #255         ; 255=silence
    beq RightSilentNote

RightNote
    sta AUDF1
    lda #1
    sta AUDC1
    sta AUDV1
   ;jmp PouetPouetPouet
    bne PouetPouetPouet ; already NE


RightSilentNote
    lda #0
    sta AUDF1
    sta AUDC1
    sta AUDV1

PouetPouetPouet
    dec NoteDuration
    beq NoteOver     ; Duration ended

NoteNotOver
    ldx NoteCurrent
    lda PartitionBegin-1,X
    cmp #255         ; If silence, no need to decay
    beq PressFire

DecayTheNote
    lda NoteDuration
    cmp #MusicVolume
    bpl PressFire    ; If duration < volume, use duration as volume
    sta AUDV0        ; Sound volume decay
    jmp PressFire

NoteOver
    dec NoteCurrent
    beq SongOver     ; Song ended

    ldx NoteCurrent
    lda PartitionBegin-1,X

    cmp #255
    beq Silence      ; If silence, skip

    sta AUDF0        ; Frequency
    lda #MusicVolume
    sta AUDV0        ; Volume
    lda #1
    sta AUDC0        ; Sound type "1"

NoteNote

    lda VideoMode
    cmp #2
    beq Not60Duration
    lda #Music60Duration
    .byte $2c        ; Skip next 2 bytes
Not60Duration
    lda #Music50Duration
    sta NoteDuration

    lda NoteCurrent
    and #1           ; Hat - Kick - Hat - Kick ...
    beq ThisIsHat

ThisIsKick
;kick drum  15/30 or 08/30
;snare drum 15/04 or 08/04 or 08/05
    lda #15          ; kick
    sta AUDC1
    lda #30
    sta AUDF1
    lda #10
    sta AUDV1
;   jmp PressFire
    bne PressFire    ; already NE

ThisIsHat
;hat 08/00
;   lda #0           ; already a=0
    sta AUDF1
    lda #8
    sta AUDC1
    lda #7
    sta AUDV1
;   jmp PressFire
    bne PressFire    ; already NE

Silence
    lda #0
    sta AUDV0
    sta AUDC0
    sta AUDF0
;   jmp NoteNote
    beq NoteNote     ; already EQ


SongOver
    lda #(PartitionEnd+1-PartitionBegin)
    sta NoteCurrent
;   jmp NoteOver
    bne NoteOver     ; already NE



;-----------------------------------------------------------------------------
;                                                          MENU BUTTONS STATES
;-----------------------------------------------------------------------------

PressFire
    lda SWCHB        ; Reset pressed ?
    and #1
    BNE NotResetMenu
    JMP Reset

NotResetMenu
    lda SWCHB        ; Select pressed ?
    and #2
    BNE NotSelectMenu

    inc VideoMode
    lda VideoMode
    cmp #3
    BNE GoSelect
    lda #0
    sta VideoMode
GoSelect
    JMP Select

NotSelectMenu
    lda MenuCurrent
    cmp #3           ; Middle choice = no choice
    beq MenuLeftRight

    lda INPT4        ; Fire pressed ?
    AND #128
    BEQ AfterTitle


MenuLeftRight
    jsr CheckLeftRight


;-----------------------------------------------------------------------------
OverScanWait
    lda INTIM
    bne OverScanWait



;-----------------------------------------------------------------------------
    JMP TitleMainLoop ; Back to begin of title's loop
;-----------------------------------------------------------------------------

AfterTitle

    lda INPT4        ; Fire still pressed ?
    AND #128
    BEQ AfterTitle




    lda MenuCurrent  ; Menu's choice
    cmp #5           ; Two players?
    bne InitVars     ; One player
    JMP InitVarsTwo  ; Two players






;-----------------------------------------------------------------------------
;                                                     INITIALISATION VARIABLES
;-----------------------------------------------------------------------------

InitVars

    lda #0
;notneeded; sta Wheels        ; Animation Wheels
    sta LineIncr     ; LineIncr
;notneeded; sta LineStart    ; LineStart
    sta DoBrake      ; Braking or not ?

    sta AUDV0
    sta AUDC0
    sta AUDF0
    sta AUDV1
    sta AUDC1
    sta AUDF1

    sta CXCLR        ; Collisions


; Road:  X=[49-103]
    lda #75          ; Road center (must be odd !)
    sta F40x         ; Ferreira's position
    ldx #1           ; For Player1
    jsr SetXPos      ; Call to repositioning code

    lda #75+3        ; Windows (using Ball)
    ldx #4           ; For Ball
    jsr SetXPos      ; Call to repositioning code

    lda #49          ; On the left
    sta P1x          ; Store player1 position


;    lda #48          ; Road side
;    ldx #2           ; Missile
;    jsr SetXPos      ; Call to repositioning code
;    lda #113         ; Road side
;    ldx #3           ; Missile
;    jsr SetXPos      ; Call to repositioning code



    sta WSYNC
    sta HMOVE        ; Let's move everybody
                     ; No HMCLR now... (but later)



    lda #120
    sta P1y          ; BadGuy's line
    lda #60
    sta P2y          ; BadGuy's line
    lda #70
    sta P3y          ; BadGuy's line
    lda #10
    sta P4y          ; BadGuy's line

    lda #75
    sta P2x
    sta P3x
    sta P4x

    lda #(BadGuyEnd-BadGuy)-1
    sta P1g
    sta P3g
    sta P4g
    lda #(BadGuyFourEnd-BadGuy)-1
;    lda #(BadGuyTwoEnd-BadGuy)-1
;    lda #(BadGuyThreeEnd-BadGuy)-1
    sta P2g

    lda #$C6         ; Green tuning color
    sta P2c
    lda #$A8         ; Grey German Color
    sta P1c
    sta P4c
    lda #$FF
    sta P3c




;-----------------------------------------------------------------------------
;                                                                    MAIN LOOP
;-----------------------------------------------------------------------------

MainLoop

    lda #2
    ldx #0
    stx VBLANK
;;;;sta WSYNC        ; Why or why not ????
    sta VSYNC
    sta WSYNC
    sta WSYNC
    sta WSYNC
    stx VSYNC

    lda #39
    sta TIM64T       ; Timer


    lda #33
    sta CTRLPF       ; PlayField = Reflect + ball4pixels

    sta HMCLR        ; Stop all moves


    ldx Palette      ; Palette to use
    lda RedFerreira,X
    sta COLUP1       ; F40 color
    lda DarkBlue,X
    sta COLUPF       ; Playfield color


    lda P1x          ; First BadGuy
    ldx #0           ; For Player1
    jsr SetXPos      ; Call to repositioning code
    sta WSYNC
    sta HMOVE

    lda P1c
    sta COLUP0       ; Player1's color


    dec LineStart
    lda DoBrake      ; Road scrolling x1 if braking
    BNE BrakingSlowdown
    dec LineStart
    dec LineStart
    dec LineStart
    dec LineStart    ; Road scrolling x5
BrakingSlowdown
    lda LineStart
    sta LineIncr




WaitForVblankEnd2
    lda INTIM
    bne WaitForVblankEnd2
    sta VBLANK


;        NTSC         PAL
;VBLANK    40  2548    48  3085
;KERNAL   192 12228   228 14656       192=64*3
;OVERSCAN  30  1910    36  2314
;FRAME    262 16686   312 20055


    sta WSYNC        ; before first line (?)



;-----------------------------------------------------------------------------
;                                                               BAD GUYS LINES
;-----------------------------------------------------------------------------



    ldx #0           ; why? why? why? why?
    ldy #145         ; 145 lines...


BadGuysLines

    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0


    CPY P1y
    BNE NotPlayer1
    ldx P1g          ; BadGuy sprite pointer
;argh    sta WSYNC
;argh    dey


NotPlayer1

    CPY P2y
    BNE NotPlayer2

    lda P2x
    ldx #0           ; Pour Player0
    jsr SetXPosAlt   ; Call to repositioning code
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta HMOVE
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    ldy P2y          ; !!! Important !!! (Y was lost)
    lda P2c
    sta COLUP0
    ldx P2g          ; BadGuy sprite pointer

NotPlayer2
    JMP NotPlayer3   ; (temp)


;;;;;;;;;;;;;;;;;;; (later) (to see)
    cpy P3y
    BNE NotPlayer3

    lda P3x
    ldx #0           ; Pour Player0
    jsr SetXPosAlt   ; Call to repositioning code
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta HMOVE
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    ldy P3y          ; !!! Important !!! (Y was lost)
    lda P3c
    sta COLUP0
    ldx P3g          ; BadGuy sprite pointer
;;;;;;;;;;;;;;;;;





NotPlayer3
    lda BadGuy,X     ; BadGuy's sprite line
    sta GRP0         ; Drawing BadGuy's sprite line
    BEQ NotDrawPlayer1  ; End of BadGuy's sprite (empty/erasing line)
    dex

NotDrawPlayer1
    dey
    BNE BadGuysLines



;-----------------------------------------------------------------------------
;                                                               GOOD GUY LINES
;-----------------------------------------------------------------------------
    ldy #30          ; Ferreira size (+cleaning)

    lda DoBrake
    BEQ DrawF40      ; Brake or not ?


    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0



    lda BadGuy,X     ; BadGuy's sprite line
    sta GRP0         ; Sprite line display
    BEQ HereBugToSolve
    dex
HereBugToSolve



DrawF40
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0

    lda F40-1,Y      ; Ferreira's sprite
    sta GRP1

    lda F40Ball-1,Y
    sta ENABL        ; Ball


    lda BadGuy,X     ; BadGuy's sprite
    sta GRP0
    BEQ NotDrawPlayer1again
    dex
NotDrawPlayer1again

    dey
    BNE DrawF40

    lda #2           ; Skid marks color (#2 for all palettes now?)
    sta COLUP1       ; Affect skid color

    ldy #15          ; 15 lines
    ldx BrakeLines   ; Skid marks lines


AfterCars
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0


    cpx #0
    BEQ NotDrawBrakes
    lda F40Brake-1,X ; Ferreira's brakes
    sta GRP1
    dex
NotDrawBrakes


    dey
    BNE AfterCars



;Brake's recoil effect
    lda DoBrake
    BNE TempTemp2
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
TempTemp2


LastLoop

    sta WSYNC
    sty PF0          ; already y=0
    sty PF1


    lda VideoMode
    cmp #2
    bne GameNotPal50

GamePal50
    lda #3
    sta LinesTitle
    lda #0           ;
    sta CTRLPF       ; Non-mirror playfield
    jsr BigLetters
    sta WSYNC        ; 312
GameNotPal50


    lda #39
    sta TIM64T

    lda #%01000010
    sta VBLANK       ; Screen end / blanking


;-----------------------------------------------------------------------------
;                                                                     JOYSTICK
;-----------------------------------------------------------------------------



GameInputChecks


    lda SWCHB        ; Reset pressed ?
    and #1
    BNE GameJoyCheck
    JMP Reset

GameJoyCheck

GameFireCheck
    lda INPT4
    and #128
    BNE DontBrake
    lda #1
    sta DoBrake
    lda #3
    sta AUDV0        ; Volume
    lda LineStart
    and #3
    sta AUDF0        ; Frequency "3"
    lda #2
    sta AUDC0        ; Sound type "2"

    lda BrakeLines
    cmp #12
    BEQ GameJoyLeftRight

    inc BrakeLines   ; Brakes lines number
;;  inc BrakeLines   ; (twice)

   ;JMP GameJoyLeftRight
    BNE GameJoyLeftRight ; Already NE

DontBrake
    lda #0
    sta DoBrake
    sta BrakeLines
    sta AUDF0        ; Silence
    sta AUDV0        ; Silence
    sta AUDC0        ; Silence

GameJoyLeftRight

    jsr CheckLeftRight



;-----------------------------------------------------------------------------
;                                                               BAD GUYS BRAIN
;-----------------------------------------------------------------------------

BadIQ
    lda F40x
    sec
    sbc P1x
    BEQ BadIdem
    BPL BadRight

BadLeft
    dec P1x
   ;JMP BadIqEnd
    bne BadIqEnd     ; Already NE

BadRight
    inc P1x
   ;JMP BadIqEnd
    bne BadIqEnd     ; Already NE

BadIdem
;   Nothing

BadIqEnd
    lda DoBrake
    BNE BadBrake
    dec P1y
    dec P2y

BadBrake

P1over
    lda P1y
    cmp #3

    BCS P2over       ; if >=


    lda #0
    sta AUDF0
    lda #8
    sta AUDC0
    lda #7
    sta AUDV0

    lda #160
    sta P1y

;;    lda LineIncr
;;    and #3
;;    tax
;;    lda BadGuysTable,X
;;    sta P1g



P2over
    lda P2y
    CMP #3
    BCS P3over       ; if >=

    lda #0
    sta AUDF0
    lda #8
    sta AUDC0
    lda #7
    sta AUDV0
    lda #160
    sta P2y

    lda LineIncr     ; Pseudo-random...
    ror
    and #3
    tax
    lda BadGuysTable,X
    sta P2g

    lda LineIncr     ; Pseudo-random...
    asl              ; Ignore last bit
    BEQ P3over       ; if not 0
    sta P2c



P3over
    lda P1y
    cmp P2y
    bcs BlinkBlink   ; if >=

SpritesSwap
    lda P2y
    ldx P1y
    sta P1y
    stx P2y

    lda P2x
    ldx P1x
    sta P1x
    stx P2x

    lda P2c
    ldx P1c
    sta P1c
    stx P2c

    lda P2g
    ldx P1g
    sta P1g
    stx P2g




;-----------------------------------------------------------------------------
;                                                                 WHEELS BLINK
;-----------------------------------------------------------------------------
BlinkBlink
    lda Wheels
    eor #8           ; XOR between 0 and 8
    sta Wheels
    sta REFP0        ; Reflection Player0
    sta REFP1        ; Reflection Player1




GameOverScanWait
    lda INTIM
    bne GameOverScanWait


    JMP MainLoop

;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------











;-----------------------------------------------------------------------------
;                                                 INITIALISATION / TWO PLAYERS
;-----------------------------------------------------------------------------
InitVarsTwo

    lda #0
    sta LineIncr     ; LineIncr
    sta DoBrake      ; Braking or not ?
;;;;sta DoBrakeTwo   ; Braking or not ?

    sta AUDV0
    sta AUDC0
    sta AUDF0
    sta AUDV1
    sta AUDC1
    sta AUDF1

    sta CXCLR        ; Collisions (not really needed ?)


    lda #1
    sta TpOneSymbol  ; TwoPlayers, symbol of first player
    lda #3
    sta TpTwoSymbol  ; TwoPlayers, symbol of second player

                     ; 0=top, 114=bottom (???)
    lda #TpZoneSize-3
    sta TpOneLine    ; line of first player
    lda #TpZoneSize-42
    sta TpTwoLine    ; line of second player



; Road:  X=[49-103]
    lda #49+15       ; Left player
    ldx #1           ; For Player1
    jsr SetXPos      ; Call to repositioning code

    lda #49+15+3     ; Windows (using Ball)
    ldx #4           ; For Ball
    jsr SetXPos      ; Call to repositioning code

    lda #49+15+8+16  ; Right player
    ldx #0           ; For Player0
    jsr SetXPos      ; Call to repositioning code

    sta WSYNC
    sta HMOVE        ; Let's move everybody
                     ; No HMCLR now... (but later)


;-----------------------------------------------------------------------------
;                                                      MAIN LOOP / TWO PLAYERS
;-----------------------------------------------------------------------------
MainLoopTwo
    lda #2
    ldx #0
    stx VBLANK
;;;;sta WSYNC        ; Why or why not ????
    sta VSYNC
    sta WSYNC
    sta WSYNC
    sta WSYNC
    stx VSYNC

    lda #39
    sta TIM64T       ; Timer

    lda #33
    sta CTRLPF       ; PlayField = Reflect + ball4pixels

    sta HMCLR        ; Stop all moves

    stx REFP0        ; Reflection Player0 ; already x=0
    stx REFP1        ; Reflection Player1 ; already x=0

    stx TpWhichCarFirst ; Which car is displayed first?

    ldx Palette      ; Palette to use
    lda RedFerreira,X
    sta COLUP1       ; F40's color
    lda LightBlue,X
    sta COLUP0       ; Right player's color
    lda DarkBlue,X
    sta COLUPF       ; Playfield color


;-----------------------------------------------------------------------------
;                                         POSITIONS COMPUTATIONS / TWO PLAYERS
;-----------------------------------------------------------------------------
; begin of display computations
    lda TpTwoLine
    cmp TpOneLine    ; (the smaller is upper on screen)
    bcs TwoBiggerThanOne

OneBiggerThanTwo     ; second player is upper than first player
    lda TpTwoLine
    sta TpBeforeCars ; number of lines before the cars

    lda TpOneLine
    sec
    sbc TpTwoLine
    sta TpBetweenCars ; number of lines between the cars

    lda #TpZoneSize
    sec
    sbc TpOneLine
    sta TpAfterCars   ; number of lines after the cars

    sta TpWhichCarFirst ; Flag to display second car before first car

    bne TpAfterComputations ; already a>0 (??)
   ;jmp TpAfterComputations

TwoBiggerThanOne     ; first player is upper than second player
    lda TpOneLine
    sta TpBeforeCars ; number of lines before the cars

    lda TpTwoLine
    sec
    sbc TpOneLine
    sta TpBetweenCars ; number of lines between the cars

    lda #TpZoneSize
    sec
    sbc TpTwoLine
    sta TpAfterCars  ; number of lines after the cars

TpAfterComputations  ; end of display computations

;-----------------------------------------------------------------------------
;                                                 BEFORE DISPLAY / TWO PLAYERS
;-----------------------------------------------------------------------------
    dec LineStart
    dec LineStart
    dec LineStart
    dec LineStart
    dec LineStart    ; Road scrolling x5
    lda LineStart
    sta LineIncr

WaitForVblankEnd2Two
    lda INTIM
    bne WaitForVblankEnd2Two
    sta VBLANK

    sta WSYNC        ; before first line (?)

;-----------------------------------------------------------------------------
;                                                  TOP OF SCREEN / TWO PLAYERS
;-----------------------------------------------------------------------------
; One empty line
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0

; Index of Symbols to display
    ldx TpOneSymbol    ; TwoPlayers, symbol of first player
    ldy SymbolTable,X  ; Y is symbol's first sprite line (+1) for left player
    ldx TpTwoSymbol    ; TwoPlayers, symbol of second player
    lda SymbolTable,X
    tax                ; X is symbol's first sprite line (+1) for right player

SymbolsTwo
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0

    dey
    lda SymbolFlag,Y ; Left symbol's sprite line
    sta GRP1         ; Drawing left symbol's sprite line

    dex
    lda SymbolFlag,X ; Right symbol's sprite line
    sta GRP0         ; Drawing right symbol's sprite line

    BNE SymbolsTwo   ; sprite's last line ?


;-----------------------------------------------------------------------------
;                                                   WHEELS BLINK / TWO PLAYERS
;-----------------------------------------------------------------------------
BlinkBlinkTwo

; Ending line
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    lda #%01100110   ; finish line
    sta PF2

    lda Wheels       ; blink the wheels
    eor #8           ; XOR between 0 and 8
    sta REFP0        ; Reflection Player0
    sta REFP1        ; Reflection Player1
    sta.w Wheels     ; (sta.w to eat one more cycle)

    ldx Palette      ; Palette to use
    lda WhiteLine,X
    sta.w COLUPF     ; Playfield color
    sta.w COLUPF     ; Eating cycles
    sta.w COLUPF     ; Eating cycles
    sta.w COLUPF     ; Eating cycles
    lda DarkBlue,X
    sta.w COLUPF     ; Playfield color

; One empty line + erasing finish line
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    lda #0
    sta PF2          ; Erasing finish line


;-----------------------------------------------------------------------------
;                                                TOP OF PLAYZONE / TWO PLAYERS
;-----------------------------------------------------------------------------
    ldy TpBeforeCars
    beq TpWeAreOnTop

TopScreenTwo
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    dey
    BNE TopScreenTwo

;-----------------------------------------------------------------------------
;                                                  PLAYERS LINES / TWO PLAYERS
;-----------------------------------------------------------------------------
TpWeAreOnTop
    lda TpWhichCarFirst
    bne TpSecondCarFirst


    ldy #30
    ldx TpBetweenCars
    beq DrawBothCarsBegin
    
DrawUpperCar
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    lda F40Ball-1,Y
    sta ENABL        ; Ball
    lda F40-1,Y      ; Ferreira's sprite
    sta GRP1
    BEQ UpperCarEnded
    dey
UpperCarEnded
    dex
    BNE DrawUpperCar


DrawBothCarsBegin
    ldx #30          ; size of second car (+cleaning)
DrawBothCars
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    lda F40Ball-1,Y
    sta ENABL        ; Ball
    lda F40-1,Y      ; Ferreira's sprite
    sta GRP1
    BEQ ButUpperCarEnded
    dey
ButUpperCarEnded
    lda BadGuy-1,X     ; BadGuy's sprite
    sta GRP0
    dex
    BNE DrawBothCars
    beq AfterTheCarsTwo


TpSecondCarFirst
    ldy #30
    ldx TpBetweenCars
  ;;beq DrawBothCarsBegin ; should be always NE (????)
    
DrawUpperCarSecond
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    lda BadGuy-1,Y   ; BadGuy's sprite
    sta GRP0
    BEQ UpperCarEndedSecond
    dey
UpperCarEndedSecond
    dex
    BNE DrawUpperCarSecond


DrawBothCarsBeginSecond
    ldx #30          ; size of second car (+cleaning)
DrawBothCarsSecond
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    lda BadGuy-1,Y   ; BadGuy's sprite
    sta GRP0
    BEQ ButUpperCarEndedSecond
    dey
ButUpperCarEndedSecond
    lda F40Ball-1,X
    sta ENABL        ; Ball
    lda F40-1,X      ; Ferreira's sprite
    sta GRP1
    dex
    BNE DrawBothCarsSecond


;-----------------------------------------------------------------------------
;                                               BOTTOM OF SCREEN / TWO PLAYERS
;-----------------------------------------------------------------------------

AfterTheCarsTwo
    ldy TpAfterCars

BottomScreenTwo
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0
    dey
    BNE BottomScreenTwo



AfterCarsTwo
    inc LineIncr
    lda LineIncr
    sta WSYNC
    sta PF1          ; PlayField1
    asl              ; Shift one bit
    sta PF0          ; Playfield0




    lda #0
    sta WSYNC
    sta PF0
    sta PF1


    lda VideoMode
    cmp #2
    bne GameNotPal50Two

GamePal50Two
    lda #3
    sta LinesTitle
    lda #0           ;
    sta CTRLPF       ; Non-mirror playfield
    jsr BigLetters
    sta WSYNC        ; 312 lines if 50hz
GameNotPal50Two


    lda #39
    sta TIM64T

    lda #%01000010
    sta VBLANK       ; Screen end / blanking

; Reset switch??
    lda SWCHB        ; Reset pressed?
    and #1
    BNE TempBeurkTwo
    JMP Reset


TempBeurkTwo
    lda LineStart
    and #31          ; (Every 32nd frame...)
    bne GameOverScanWaitTwo

    lda TpOneLine
    beq TempBeurkTwoMore ; line=0 = top of screen
    dec TpOneLine
    lda TpOneLine
    beq TempBeurkTwoMore ; line=0 = top of screen
    dec TpOneLine

    inc TpOneSymbol
    lda TpOneSymbol
    cmp #5
    bne TempBeurkTwoMore
    lda #1
TempBeurkTwoMore
    sta TpOneSymbol

    lda TpTwoLine
    beq TempBeurkTwoEnd
    dec TpTwoLine

    inc TpTwoSymbol
    lda TpTwoSymbol
    cmp #5
    bne TempBeurkTwoEnd
    lda #1
TempBeurkTwoEnd
    sta TpTwoSymbol



GameOverScanWaitTwo
    lda INTIM
    bne GameOverScanWaitTwo
    JMP MainLoopTwo













;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------


    align 256,0      ; All these called routines need exact timings


;-----------------------------------------------------------------------------
;                                                  HORIZONTAL POSITION ROUTINE
;-----------------------------------------------------------------------------
SetXPos
    sec
    sta WSYNC
WaitObject:
    sbc #$0f         ;2
    bcs WaitObject   ;2  waste cycles
    eor #$07         ;2  adjust nibble
    asl              ;2  shift bits for correct HMXX value
    asl              ;2
    asl              ;2
    asl              ;2
    sta HMP0,x       ;4  store in HMXX (fine adjust)
    sta.wx RESP0,x   ;5  then reset position
    rts              ;   Return to code


SetXPosAlt
    inc LineIncr
    ldy LineIncr
    sec
    sta WSYNC
    sty.w PF1         ;4 PlayField1  (sty.w is 4, sty is only 3)
WaitObjectAlt:
    sbc #$0f          ;2
    bcs WaitObjectAlt ;2  waste cycles
    eor #$07          ;2  adjust nibble
    asl               ;2  shift bits for correct HMXX value
    asl               ;2
    asl               ;2
    asl               ;2
    sta.wx RESP0,x    ;5  reset position
    sta HMP0,x        ;4  then store in HMXX (fine adjust)
;;    tya             ;not enough time
;;    asl             ;not enough time
;;    sta PF0         ;not enough time
    rts               ;   Return to code


;-----------------------------------------------------------------------------
;                                                                  BIG LETTERS
;-----------------------------------------------------------------------------

BigLetters
    ldx #16               ; Number of lines in Title

TitleLines
    ldy LinesTitle        ; Displayed lines per title line

TitleSameLine
    sta WSYNC
    lda PFData0Left-1,X   ;[0]+4
    sta PF0               ;[4]+3 = *7*   < 23     ;PF0 visible
    lda PFData1Left-1,X   ;[7]+4
    sta PF1               ;[11]+3 = *14*  < 29    ;PF1 visible
    lda PFData2Left-1,X   ;[14]+4
    sta PF2               ;[18]+3 = *21*  < 40    ;PF2 visible
    nop                   ;[21]+2  ; Six cycles free here
    nop                   ;[23]+2
    nop                   ;[25]+2 = *27*
    lda PFData0Right-1,X  ;[27]+4  ;PF0 no longer visible, safe to rewrite
    sta PF0               ;[31]+3 = *34*
    lda PFData1Right-1,X  ;[34]+4  ;PF1 no longer visible, safe to rewrite
    sta PF1               ;[38]+3 = *41*
    lda PFData2Right-1,X  ;[41]+4  ;PF2 rewrite must begin at exactly cycle 45
    sta PF2               ;[45]+2 = *47*

    dey
    bne TitleSameLine
    dex
    bne TitleLines

AfterBigLetters
    sta WSYNC
    stx PF2          ; already x=0  ; (PF2 first? why?)
    stx PF0
    stx PF1
    rts



;-----------------------------------------------------------------------------
;                                                      COLORS PALETTES ROUTINE
;-----------------------------------------------------------------------------
SetPalette

    lda SWCHB
    and #8
    BNE ColorSwitch  ; Switch is Color
    lda #2           ; Palette is Secam/BW
    BNE SetPaletteEnd  ; Already NE
   ;JMP SetPaletteEnd

ColorSwitch
    lda VideoMode
    BEQ NotPal       ; VideMode is Ntsc
    lda #1           ; Palette is Pal
   ;.byte $2c        ; Skip next 2 bytes ; Not needed
NotPal
   ;lda #0           ; Palette is Ntsc ; Already 0

SetPaletteEnd
    sta Palette
    rts


;-----------------------------------------------------------------------------
;                                                  FERREIRA LEFT RIGHT ROUTINE
;-----------------------------------------------------------------------------

CheckLeftRight

JoyRightCheck
    lda SWCHA
    and #128
    BNE JoyLeftCheck

    lda F40x
    cmp #103         ; Limit=103
    BEQ JoyCenter

JoyDoRight
    lda #$E0
    sta HMP1
    sta HMBL
    inc F40x
    inc F40x
   ;JMP JoystickEnd
    BNE JoystickEnd  ; Already NE

JoyLeftCheck
    lda SWCHA
    and #64
    BNE JoyCenter

    lda F40x
    cmp #49          ; Limit=49
    BEQ JoyCenter

JoyDoLeft
    lda #$20
    sta HMP1
    sta HMBL
    dec F40x
    dec F40x
   ;JMP JoystickEnd
    BNE JoystickEnd  ; Already NE

JoyCenter
    lda #0
    sta HMP1
    sta HMBL

JoystickEnd
    sta WSYNC
    sta HMOVE        ; Move the Ferreira

    rts              ; return


;-----------------------------------------------------------------------------
;                                                                      SPRITES
;-----------------------------------------------------------------------------
    include f40graph.h

;-----------------------------------------------------------------------------
;                                                                 TITLE SCREEN
;-----------------------------------------------------------------------------
    include f40title.h

;-----------------------------------------------------------------------------
;                                                                  TITLE MUSIC
;-----------------------------------------------------------------------------
    include f40music.h

;-----------------------------------------------------------------------------
;                                                                  END OF CODE
;-----------------------------------------------------------------------------
    .byte "<END>"
    echo ">>>>>",(*-$F000), "total ROM bytes used <<<<<"

    org $FFF7
    .byte "NOT"      ; For SuperCharger compatibility

    org $FFFC
    .word Start
    .word Start
